package svc

import (
	"applet/app/admin/md"
	"applet/app/db"
	"applet/app/db/model"
	"encoding/json"
	"errors"
	"time"
)

func AddCentralKitchenForSchoolPackageForSystem(req md.SaveCentralKitchenForSchoolPackageForSystemReq) (err error) {
	session := db.Db.NewSession()
	defer session.Close()
	session.Begin()
	now := time.Now()
	//TODO::判断当前月份是否存在
	centralKitchenForSchoolPackageForSystemDb := db.CentralKitchenForSchoolPackageForSystemDb{}
	centralKitchenForSchoolPackageForSystemDb.Set()
	isHasPackage, err := centralKitchenForSchoolPackageForSystemDb.GetCentralKitchenForSchoolPackageForSystemByMonth(req.Year, req.Month)
	if err != nil {
		return err
	}
	if isHasPackage != nil {
		return errors.New("请勿重复添加【" + req.Month + "】套餐")
	}

	//新增`central_kitchen_for_school_package`
	var centralKitchenForSchoolPackageForSystemWithDays []*md.CentralKitchenForSchoolPackageForSystemWithDay
	for _, v := range req.DateList {
		centralKitchenForSchoolPackageForSystemWithDays = append(centralKitchenForSchoolPackageForSystemWithDays, &md.CentralKitchenForSchoolPackageForSystemWithDay{
			Date:            v.Date,
			IsOpenBreakfast: v.IsOpenBreakfast,
			IsOpenLunch:     v.IsOpenLunch,
			IsOpenDinner:    v.IsOpenDinner,
			IsOpenReplenish: v.IsOpenReplenish,
		})
	}
	centralKitchenForSchoolPackageForSystemWithDaysStr, _ := json.Marshal(centralKitchenForSchoolPackageForSystemWithDays)
	_, err = centralKitchenForSchoolPackageForSystemDb.CentralKitchenForSchoolPackageForSystemInsertBySession(session, &model.CentralKitchenForSchoolPackageForSystem{
		Id:         0,
		Year:       req.Year,
		Month:      req.Month,
		TotalPrice: "0",
		StartDate:  req.StartDate,
		EndDate:    req.EndDate,
		WithDate:   string(centralKitchenForSchoolPackageForSystemWithDaysStr),
		CreateAt:   now.Format("2006-01-02 15:04:05"),
		UpdateAt:   now.Format("2006-01-02 15:04:05"),
	})

	if err != nil {
		_ = session.Rollback()
		return err
	}
	return session.Commit()
}

func SyncCentralKitchenForSchoolPackageForSystem(req md.SyncCentralKitchenForSchoolPackageForSystemReq) (err error) {
	centralKitchenForSchoolWithSpecForSystemDb := db.CentralKitchenForSchoolWithSpecForSystem{}
	centralKitchenForSchoolWithSpecForSystemDb.Set()
	centralKitchenForSchoolWithSpecForSystem, err := centralKitchenForSchoolWithSpecForSystemDb.GetCentralKitchenForSchoolWithSpecForSystem()
	if err != nil {
		return err
	}
	if centralKitchenForSchoolWithSpecForSystem == nil && req.IsCarryPackagePrice {
		return errors.New("未设置套餐价格")
	}

	session := db.Db.NewSession()
	defer session.Close()
	session.Begin()
	now := time.Now()
	centralKitchenForSchoolPackageDb := db.CentralKitchenForSchoolPackageDb{}
	centralKitchenForSchoolPackageDb.Set()
	for _, id := range req.Ids {
		centralKitchenForSchoolPackageForSystemDb := db.CentralKitchenForSchoolPackageForSystemDb{}
		centralKitchenForSchoolPackageForSystemDb.Set()
		centralKitchenForSchoolPackageForSystem, err1 := centralKitchenForSchoolPackageForSystemDb.GetCentralKitchenForSchoolPackageForSystem(id)
		if err1 != nil {
			return err1
		}
		if centralKitchenForSchoolPackageForSystem == nil {
			return errors.New("套餐记录不存在")
		}
		var withDate []*md.CentralKitchenForSchoolPackageForSystemWithDay
		err2 := json.Unmarshal([]byte(centralKitchenForSchoolPackageForSystem.WithDate), &withDate)
		if err2 != nil {
			_ = session.Rollback()
			return err2
		}

		for _, v := range req.EnterpriseIds {
			//1、查询对应校企
			enterpriseDb := db.EnterpriseDb{}
			enterpriseDb.Set()
			enterprise, err3 := enterpriseDb.GetEnterprise(v)
			if err3 != nil {
				_ = session.Rollback()
				return err3
			}

			//TODO::判断当前月份是否存在
			isHasPackage, err4 := centralKitchenForSchoolPackageDb.GetCentralKitchenForSchoolPackageByMonth(v, centralKitchenForSchoolPackageForSystem.Year, centralKitchenForSchoolPackageForSystem.Month)
			if err4 != nil {
				return err4
			}
			if isHasPackage != nil {
				_ = session.Rollback()
				return errors.New("请勿重复添加【" + enterprise.Name + "单位下】，【" + centralKitchenForSchoolPackageForSystem.Year + "-" + centralKitchenForSchoolPackageForSystem.Month + "】的套餐")
			}

			//2、查询`central_kitchen_for_school_with_spec`
			centralKitchenForSchoolWithSpec := db.CentralKitchenForSchoolWithSpec{}
			centralKitchenForSchoolWithSpec.Set(v)
			spec, err5 := centralKitchenForSchoolWithSpec.GetCentralKitchenForSchoolWithSpec()
			if err5 != nil {
				_ = session.Rollback()
				return err5
			}

			//3、新增`central_kitchen_for_school_package`
			packageId, err6 := centralKitchenForSchoolPackageDb.CentralKitchenForSchoolPackageInsertBySession(session, &model.CentralKitchenForSchoolPackage{
				EnterpriseId: v,
				Year:         centralKitchenForSchoolPackageForSystem.Year,
				Month:        centralKitchenForSchoolPackageForSystem.Month,
				TotalPrice:   "0",
				StartDate:    centralKitchenForSchoolPackageForSystem.StartDate,
				EndDate:      centralKitchenForSchoolPackageForSystem.EndDate,
				State:        1,
				CreateAt:     now.Format("2006-01-02 15:04:05"),
				UpdateAt:     now.Format("2006-01-02 15:04:05"),
			})
			if err6 != nil {
				_ = session.Rollback()
				return err6
			}

			//4、批量新增 `central_kitchen_for_school_package_with_day`
			var centralKitchenForSchoolPackageWithDays []*model.CentralKitchenForSchoolPackageWithDay
			for _, v := range withDate {
				var isOpenBreakfast, isOpenLunch, isOpenDinner, isOpenReplenish = md.CloseBreakfast, md.CloseLunch, md.CloseDinner, md.CloseReplenish
				if v.IsOpenBreakfast == md.OpenBreakfast {
					isOpenBreakfast = md.OpenBreakfast
				}
				if v.IsOpenLunch == md.OpenLunch {
					isOpenLunch = md.OpenLunch
				}
				if v.IsOpenDinner == md.OpenDinner {
					isOpenDinner = md.OpenDinner
				}
				if v.IsOpenReplenish == md.OpenReplenish {
					isOpenReplenish = md.OpenReplenish
				}
				centralKitchenForSchoolPackageWithDays = append(centralKitchenForSchoolPackageWithDays, &model.CentralKitchenForSchoolPackageWithDay{
					Date:            v.Date,
					PackageId:       packageId,
					IsOpenBreakfast: isOpenBreakfast,
					IsOpenLunch:     isOpenLunch,
					IsOpenDinner:    isOpenDinner,
					IsOpenReplenish: isOpenReplenish,
				})
			}
			centralKitchenForSchoolPackageWithDayDb := db.CentralKitchenForSchoolPackageWithDayDb{}
			centralKitchenForSchoolPackageWithDayDb.Set(packageId)
			_, err7 := centralKitchenForSchoolPackageWithDayDb.BatchAddCentralKitchenForSchoolPackageWithDaysBySession(session, centralKitchenForSchoolPackageWithDays)
			if err7 != nil {
				_ = session.Rollback()
				return err7
			}

			// 8、判断是否 "是否跟随套餐价格"
			if req.IsCarryPackagePrice {
				spec.BreakfastUnitPrice = centralKitchenForSchoolWithSpecForSystem.BreakfastUnitPrice
				spec.LunchUnitPrice = centralKitchenForSchoolWithSpecForSystem.LunchUnitPrice
				spec.DinnerUnitPrice = centralKitchenForSchoolWithSpecForSystem.DinnerUnitPrice
				spec.BreakfastUnitPriceForTeacher = centralKitchenForSchoolWithSpecForSystem.BreakfastUnitPriceForTeacher
				spec.LunchUnitPriceForTeacher = centralKitchenForSchoolWithSpecForSystem.LunchUnitPriceForTeacher
				spec.DinnerUnitPriceForTeacher = centralKitchenForSchoolWithSpecForSystem.DinnerUnitPriceForTeacher
				_, err8 := centralKitchenForSchoolWithSpec.CentralKitchenForSchoolWithSpecUpdate(spec.Id, spec, "breakfast_unit_price", "lunch_unit_price", "dinner_unit_price", "breakfast_unit_price_for_teacher", "lunch_unit_price_for_teacher", "dinner_unit_price_for_teacher")
				if err8 != nil {
					_ = session.Rollback()
					return err8
				}
			}
		}
	}

	return session.Commit()
}

func UpdateCentralKitchenForSchoolPackageForSystem(req md.SaveCentralKitchenForSchoolPackageForSystemReq) (err error) {
	session := db.Db.NewSession()
	defer session.Close()
	session.Begin()
	now := time.Now()

	//修改`central_kitchen_for_school_package`
	centralKitchenForSchoolPackageForSystemDb := db.CentralKitchenForSchoolPackageForSystemDb{}
	centralKitchenForSchoolPackageForSystemDb.Set()
	centralKitchenForSchoolPackageForSystem, err := centralKitchenForSchoolPackageForSystemDb.GetCentralKitchenForSchoolPackageForSystem(req.Id)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if centralKitchenForSchoolPackageForSystem == nil {
		_ = session.Rollback()
		return errors.New("未查询到对应套餐记录")
	}
	var centralKitchenForSchoolPackageForSystemWithDays []*md.CentralKitchenForSchoolPackageForSystemWithDay
	for _, v := range req.DateList {
		centralKitchenForSchoolPackageForSystemWithDays = append(centralKitchenForSchoolPackageForSystemWithDays, &md.CentralKitchenForSchoolPackageForSystemWithDay{
			Date:            v.Date,
			IsOpenBreakfast: v.IsOpenBreakfast,
			IsOpenLunch:     v.IsOpenLunch,
			IsOpenDinner:    v.IsOpenDinner,
			IsOpenReplenish: v.IsOpenReplenish,
		})
	}
	centralKitchenForSchoolPackageForSystemWithDaysStr, _ := json.Marshal(centralKitchenForSchoolPackageForSystemWithDays)
	centralKitchenForSchoolPackageForSystem.Year = req.Year
	centralKitchenForSchoolPackageForSystem.Month = req.Month
	centralKitchenForSchoolPackageForSystem.StartDate = req.StartDate
	centralKitchenForSchoolPackageForSystem.EndDate = req.EndDate
	centralKitchenForSchoolPackageForSystem.WithDate = string(centralKitchenForSchoolPackageForSystemWithDaysStr)
	centralKitchenForSchoolPackageForSystem.UpdateAt = now.Format("2006-01-02 15:04:05")
	affected, err := centralKitchenForSchoolPackageForSystemDb.CentralKitchenForSchoolPackageForSystemUpdateBySession(session, centralKitchenForSchoolPackageForSystem.Id, centralKitchenForSchoolPackageForSystem)
	if err != nil {
		_ = session.Rollback()
		return
	}
	if affected == 0 {
		_ = session.Rollback()
		return errors.New("更新套餐记录失败")
	}
	return session.Commit()
}

func DeleteCentralKitchenForSchoolPackageForSystem(packageId int) (err error) {
	//1、删除`central_kitchen_for_school_package`
	centralKitchenForSchoolPackageForSystemDb := db.CentralKitchenForSchoolPackageForSystemDb{}
	centralKitchenForSchoolPackageForSystemDb.Set()
	centralKitchenForSchoolPackage, err := centralKitchenForSchoolPackageForSystemDb.GetCentralKitchenForSchoolPackageForSystem(packageId)
	if err != nil {
		return err
	}
	if centralKitchenForSchoolPackage == nil {
		return errors.New("未查询到对应套餐记录")
	}
	affected, err := centralKitchenForSchoolPackageForSystemDb.CentralKitchenForSchoolPackageForSystemDelete(packageId)
	if err != nil {
		return
	}
	if affected == 0 {
		return errors.New("删除套餐记录失败")
	}

	//2、
	return
}
